#include "space_station.h"
#include "ship.h"
#include "objimport.h"

#define STATION_SBRE_MODEL  65

static ObjParams params = {
  { 0.5, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
  { 1, 0, 0, 0, 0, 0, 0, 0, 0, 0 },
  { 0.0f, 0.0f, 1.0f }, { 0.0f, 0.0f, 0.0f },

  /* pColor[3] */
  {
    { { 1.0f, 0.0f, 1.0f }, { 0, 0, 0 }, { 0, 0, 0 }, 0 },
    { { 0.8f, 0.6f, 0.5f }, { 0, 0, 0 }, { 0, 0, 0 }, 0 },
    { { 0.5f, 0.5f, 0.5f }, { 0, 0, 0 }, { 0, 0, 0 }, 0 }
  },

  /* pText[3][256] */
  { "Hello you!", "CATZ" },
};

SpaceStation::SpaceStation(void) : StaticRigidBody() {
  SetGeomFromSBREModel(STATION_SBRE_MODEL, &params);
  matrix4x4d m = matrix4x4d::RotateYMatrix(M_PI);
  dMatrix3 _m;
  m.SaveToOdeMatrix(_m);
  dGeomSetRotation(m_geom, _m);
  m_mesh = 0;
}

SpaceStation::~SpaceStation(void) {
  //dGeomDestroy(m_geom);
}

bool SpaceStation::OnCollision(Body* b) {
  return true;

  if(b->GetType() == Object::SHIP) {
    Ship* s = static_cast<Ship*>(b);
    if(!s->GetDockedWith()) {
      s->SetDockedWith(this);
      printf("docking!\n");
    }
    return false;
  } else {
    return true;
  }
}

void SpaceStation::SetMesh(ObjMesh* m) {
  m_mesh = m;
}

void SpaceStation::Render(const Frame* camFrame) {
  RenderSbreModel(camFrame, STATION_SBRE_MODEL, &params);
}

